@ECHO OFF
REM  SM7 update [ from 7.00, 7.10, 7.11, 7.12 ]
REM
set LOGFILE=nul
set STARTTIME=%time: =0%
set LOGFILE="%AppData%\SM7xx_%date:~0,4%%date:~5,2%%date:~8,2%-%STARTTIME:~0,2%%STARTTIME:~3,2%.log"
set SM_PATH=
set SRVSTOPERR=0
set COPYERR=0
set SM7CONVERR=0
set REGUPERRR=0
set SRVSTARTERR=0
set RETURNCODE=0



REM
REM  start update
REM
echo #####  start ESMPRO/ServerManager update  #####
echo #####  start ESMPRO/ServerManager update  ##### >> %LOGFILE%
echo %date% %time% >> %LOGFILE%
rem ------ Check 32bit or 64bit ------
IF "%PROCESSOR_ARCHITECTURE%"=="AMD64" (
	echo 64bit OS >> %LOGFILE%
	set SM_REGKEY=HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\NEC\ESMWEB
) ELSE (
	echo 32bit OS >> %LOGFILE%
	set SM_REGKEY=HKEY_LOCAL_MACHINE\SOFTWARE\NEC\ESMWEB
)


REM
REM  check SM install
REM
echo ---- Check SM install and version ---- >> %LOGFILE% 2>&1
REM reg query %SM_REGKEY% /v CurrentVersion >nul 2>&1
reg query %SM_REGKEY% /v CurrentVersion >> %LOGFILE% 2>&1
if ERRORLEVEL 1 (
		echo ESMPRO/ServerManagerCXg[Ă܂
		echo ESMPRO/ServerManagerCXg[Ă܂ >> %LOGFILE%
		set RETURNCODE=1
		goto END_UPDATE
)
REM
REM  check SM version & update
REM
reg query %SM_REGKEY% /v CurrentVersion | find "7.12" >nul 2>&1
if ERRORLEVEL 1 (
	reg query %SM_REGKEY% /v CurrentVersion | find "7.11" >nul 2>&1
	if ERRORLEVEL 1 (
		reg query %SM_REGKEY% /v CurrentVersion | find "7.10" >nul 2>&1
		if ERRORLEVEL 1 (
			reg query %SM_REGKEY% /v CurrentVersion | find "7.00" >nul 2>&1
			if ERRORLEVEL 1 (
				echo {Abvf[g̑Ώۃo[Wł͂܂
				echo {Abvf[g̑Ώۃo[Wł͂܂ >> %LOGFILE%
				set RETURNCODE=1
				goto END_UPDATE
			)
		)
	)
)

REM
REM  get SM install folder
REM
echo ---- Get install path ---- >> %LOGFILE%
reg query %SM_REGKEY% /v PathName >> %LOGFILE% 2>&1
set ValueName=PathName
for /f "tokens=1,2*" %%i in ('reg query "%SM_REGKEY%" /v "%ValueName%"' ) DO (
	if "%%i"=="%ValueName%" (
		set SM_PATH=%%k
	)
)
echo SM_PATH = %SM_PATH% >> %LOGFILE%


REM
REM  stop service
REM
echo ### T[rX~ ###
echo ### T[rX~ ### >> %LOGFILE%
call :StopService "ESMPRO/SM Web Service"
call :StopService "ESMPRO/SM Task Service"
call :StopService "DianaScope ModemAgent"
call :StopService "ESMPRO/SM Web Container"
call :StopService "ESMPRO/SM Event Manager"
call :StopService "ESMPRO/SM Base Alert Listener"
call :StopService "ESMPRO/SM Common Component"
call :StopService "ESM32BridgeService for AlertListener"
call :StopService "ESM32BridgeService for NvAccessor"
call :StopService "Alert Manager Socket(R) Service"
call :StopService "ESMPRO/SM Base Service"
call :StopService "Dmi Event Watcher"
call :StopService "ESM Alert Service"
call :StopService "ESM Command Service"
call :StopService "ESM Remote Map Service"
call :StopService "ESM Base Service"
call :StopService "Alert Manager HTTPS Service"
call :StopService "Alert Manager WMI Service"
if %SRVSTOPERR%==1 (
	echo ~ɃG[T[rX܂B
	echo ~ɃG[T[rX܂B >> %LOGFILE%
	echo OmFĂ
	echo OmFĂ >> %LOGFILE%
	set RETURNCODE=2
	goto END_UPDATE
)



REM
REM  update file(s)
REM
echo ### t@CRs[ ###
echo ### t@CRs[ ### >> %LOGFILE%
call :UpdateFile ESMWEB\wbserver\webapps\esmpro\WEB-INF\classes\com\nec\jp\dianascope\alert\receiver\nvbase  ReportStatusMonitoringManager.class
call :UpdateFile ESMWEB\wbserver\webapps\esmpro\WEB-INF\classes\com\nec\jp\dianascope\imlmonitoring          ImlMonitoringManager.class
call :UpdateFile ESMWEB\wbserver\webapps\esmpro\WEB-INF\classes\com\nec\jp\dianascope\imlmonitoring          ImlMonitoringManager$AddPeriodicMonitoringTask.class
if %COPYERR%==1 (
	echo t@CRs[ɃG[܂B
	echo t@CRs[ɃG[܂B >> %LOGFILE%
	echo OmFĂ
	echo OmFĂ >> %LOGFILE%
)



REM
REM  start service
REM
echo ### T[rXJn ###
echo ### T[rXJn ### >> %LOGFILE%
call :StartService "AlertManagerWMIService"
call :StartService "AlertManagerHTTPSService"
call :StartService "Nvbase"
call :StartService "Nvrmapd"
call :StartService "Nvcmd"
call :StartService "ESMASVNT"
call :StartService "DmiEventWatcher"
call :StartService "ESMDSVNT"
call :StartService "AlertManagerSocketReceiveService"
call :StartService "ESM32BridgeNvAccessor"
call :StartService "ESM32BridgeAlertListener"
call :StartService "ESMCommonComponent"
call :StartService "ESMBaseAlertListener"
call :StartService "ESMEventManager"
call :StartService "ESMWebContainer"
call :StartService "DianaScope ModemAgent"
call :StartService "ESM7Task"
call :StartService "ESM7Web"
if %SRVSTARTERR%==1 (
	echo XVLɂ邽߂ɁAVXeċNĂ
	echo XVLɂ邽߂ɁAVXeċNĂ >> %LOGFILE%
)



REM
REM  finish update
REM
:END_UPDATE
IF %RETURNCODE%==0 (
	echo Update End
) ELSE (
	echo error code : %RETURNCODE%
)
if not "%1"=="/s" pause
exit /b %RETURNCODE%



rem -----------------------------------------
rem  sub-routine (update file)
rem -----------------------------------------
:UpdateFile
echo %2

rem  1: rename org file
if exist "%SM_PATH%\%1\%2" (
	if exist "%SM_PATH%\%1\%2.7xx" (
		del /f "%SM_PATH%\%1\%2.7xx2" >nul
	)
	ren "%SM_PATH%\%1\%2" %2.7xx >nul
)

rem  2: copy new file
echo %2 to "%SM_PATH%\%1" >> %LOGFILE%
copy /y "%~dp0module\%2" "%SM_PATH%\%1\%2" >> %LOGFILE% 2>&1
if errorlevel 1 (
	set COPYERR=1
	echo Rs[ɃG[ >> %LOGFILE%
)
exit /b 0

rem -----------------------------------------
rem  sub-routine (stop service)
rem -----------------------------------------
:StopService
echo %1
net start | find %1 >nul 2>&1
IF %ERRORLEVEL%==0 (
	net stop /y %1 >> %LOGFILE% 2>&1
	if errorlevel 1 (
		set SRVSTOPERR=1
		echo ~ɃG[ >> %LOGFILE%
	)
) else (
	echo %1 not RUNNING >> %LOGFILE%
)
exit /b 0

rem -----------------------------------------
rem  sub-routine (start service)
rem  %1 is service name (NOT display name)
rem -----------------------------------------
:StartService
echo %1
sc qc %1 | findstr AUTO_START >nul 2>&1
IF %ERRORLEVEL%==0 (
	net start %1 >> %LOGFILE% 2>&1
	if errorlevel 1 (
		set SRVSTARTERR=1
		echo JnɃG[ >> %LOGFILE%
	)
) else (
	echo %1 not AUTO_START >> %LOGFILE%
)
exit /b 0
